<script setup lang="ts">
import { useRoute } from 'vue-router';
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from '@ant-design-vue/pro-layout';
import { Form, message } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { uploadLicense, listLicense } from '@/api/configManage/license';
import useI18n from '@/hooks/useI18n';
import useNeInfoStore from '@/store/modules/neinfo';
import { FileType } from 'ant-design-vue/lib/upload/interface';
import { UploadRequestOption } from 'ant-design-vue/lib/vc-upload/interface';
const { t } = useI18n();
const route = useRoute();

/**路由标题 */
let title = ref<string>((route.meta.title as string) ?? '标题');

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'id',
    align: 'center',
  },
  {
    title: t('views.configManage.license.neType'),
    dataIndex: 'neType',
    align: 'center',
  },
  {
    title: t('views.configManage.license.neId'),
    dataIndex: 'neId',
    align: 'center',
  },
  {
    title: t('views.configManage.license.fileName'),
    dataIndex: 'fileName',
    align: 'center',
  },
  {
    title: t('views.configManage.license.comment'),
    dataIndex: 'comment',
    align: 'center',
  },
  {
    title: t('views.configManage.license.createTime'),
    dataIndex: 'createdAt',
    align: 'center',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**查询信息列表 */
function fnGetList() {
  if (tableState.loading) return;
  tableState.loading = true;
  listLicense(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**网元版本历史框是否显示 */
  visibleByHistory: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByEdit: false,
  visibleByHistory: false,
  title: '任务设置',
  from: {
    neType: undefined,
    comment: '',
    file: undefined,
    fileList: [],
  },
  confirmLoading: false,
});

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit() {
  modalState.title = t('common.uploadText');
  modalState.visibleByEdit = true;
}

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    neType: [
      {
        required: true,
        message: t('views.configManage.license.neTypePlease'),
      },
    ],
    comment: [
      {
        required: true,
        message: t('views.configManage.license.updateCommentPlease'),
      },
    ],
    file: [
      {
        required: true,
        message: t('views.configManage.license.updateFilePlease'),
      },
    ],
  })
);

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  modalStateFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      let formData = new FormData();
      formData.append('nfType', from.neType[0]);
      formData.append('nfId', from.neType[1]);
      formData.append('comment', from.comment);
      formData.append('file', from.file);
      const hide = message.loading({ content: t('common.loading') });
      uploadLicense(formData)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByEdit = false;
            modalStateFrom.resetFields();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
          // 获取列表数据
          fnGetList();
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByEdit = false;
  modalState.visibleByHistory = false;
  modalStateFrom.resetFields();
}

/**上传前检查或转换压缩 */
function fnBeforeUploadFile(file: FileType) {
  if (modalState.confirmLoading) return false;
  const fileName = file.name;
  const suff = fileName.substring(fileName.lastIndexOf('.'));
  if (!['.ini'].includes(suff)) {
    message.error('只支持上传文件格式(.ini)', 3);
    return false;
  }
  const isLt60M = file.size / 1024 / 1024 > 60;
  if (isLt60M) {
    message.error('有效软件文件大小应不小于 60MB', 3);
    return false;
  }
  return true;
}

/**上传文件 */
function fnUploadFile(up: UploadRequestOption) {
  // 改为完成状态
  const file = modalState.from.fileList[0];
  file.percent = 100;
  file.status = 'done';
  // 预置到表单
  modalState.from.file = up.file;
}

/**上传文件 */
function fnUploadCms(up: UploadRequestOption) {
  // 改为完成状态
  const file = modalState.from.cmsList[0];
  file.percent = 100;
  file.status = 'done';
  // 预置到表单
  modalState.from.cms = up.file;
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        // 获取列表数据
        fnGetList();
      } else {
        message.warning({
          content: `暂无网元列表数据`,
          duration: 2,
        });
      }
    });
});
</script>

<template>
  <PageContainer :title="title">
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.configManage.license.neType')"
              name="neType "
            >
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="useNeInfoStore().getNeSelectOtions"
                allow-clear
                :placeholder="t('views.configManage.license.neTypePlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
            <template #icon><UploadOutlined /></template>
            {{ t('common.uploadText') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
      >
      </a-table>
    </a-card>

    <!-- 上传框 -->
    <a-modal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 4 }"
      >
        <a-form-item
          :label="t('views.configManage.license.neType')"
          name="neType"
          v-bind="modalStateFrom.validateInfos.neType"
        >
          <a-cascader
            v-model:value="modalState.from.neType"
            :options="useNeInfoStore().getNeCascaderOtions"
            :allow-clear="false"
            :placeholder="t('views.configManage.license.neTypePlease')"
          />
        </a-form-item>

        <a-form-item
          :label="t('views.configManage.license.updateComment')"
          name="comment"
          v-bind="modalStateFrom.validateInfos.comment"
        >
          <a-textarea
            v-model:value="modalState.from.comment"
            :auto-size="{ minRows: 4, maxRows: 6 }"
            :maxlength="200"
            :show-count="true"
            :placeholder="t('views.configManage.license.updateCommentPlease')"
          />
        </a-form-item>
        <a-form-item
          :label="t('views.configManage.license.updateFile')"
          name="file"
          v-bind="modalStateFrom.validateInfos.file"
        >
          <a-upload
            name="file"
            v-model:file-list="modalState.from.fileList"
            accept=".ini"
            list-type="text"
            :max-count="1"
            :show-upload-list="true"
            :before-upload="fnBeforeUploadFile"
            :custom-request="fnUploadFile"
          >
            <a-button type="default" :loading="modalState.confirmLoading">
              {{ t('views.configManage.license.selectFile') }}
            </a-button>
          </a-upload>
        </a-form-item>
      </a-form>
    </a-modal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
